#include "SR04.h"
#define TRIG_PIN 5
#define ECHO_PIN 6
SR04 sr04 = SR04(ECHO_PIN, TRIG_PIN);
long a;




#include "IRremote.h"
int RECV_PIN = 12;
IRrecv irrecv(RECV_PIN);
decode_results results;

//Below are the symbolic constants. Instead of having to type in a non-sensical pin number each time we want to do something we can write an easy to understand name which represents the pin, the compiler will then replace the names with the numbers
#define LeftMotorForward 10
#define LeftMotorBackward 11
#define RightMotorForward 8
#define RightMotorBackward 9


#define redoff = FD00FF;  //16580863     This is an example of where to type the numbers from the online converter
#define volup = FD807F;  //16613503
#define skipforward = FD609F;  //16605343                  https://www.binaryhexconverter.com/hex-to-decimal-converter
#define skipback = FD20DF;  //16589023
#define voldown = FD906F;  //16617583

int led = 7;


void setup()                                            //This block happens once on startup
{
  Serial.begin(9600);                              //I have included the serial initialize but commented it out, if you want to debug and print information to the serial monitor just uncomment
  pinMode(LeftMotorForward, OUTPUT);
  pinMode(LeftMotorBackward, OUTPUT);
  pinMode(RightMotorForward, OUTPUT);
  pinMode(RightMotorBackward, OUTPUT);

  pinMode(led, OUTPUT);
  digitalWrite(led, LOW);

  irrecv.enableIRIn();
}

void loop() {
  a = sr04.Distance();


  if (a <= 15) {
    Serial.println("");
    Serial.println("Stopping");
    digitalWrite(LeftMotorBackward, LOW);
    digitalWrite(LeftMotorForward, LOW);
    digitalWrite(RightMotorForward, LOW);
    digitalWrite(RightMotorBackward, LOW);
    moveStop();
  }

  digitalWrite(led, LOW);
  if (irrecv.decode(&results)) {
    Serial.println(results.value, HEX);
    irrecv.resume(); // Receive the next value


    switch (results.value) {
      case 16580863:
        moveStop();                  //this is the button in the middle of the direction arrows (select)
        digitalWrite(led, HIGH);
        delay(300);
        break;

      case 16613503:
        moveForward();               //Up arrow
        digitalWrite(led, HIGH);
        delay(300);
        break;

      case 16605343:
        moveRight();
        digitalWrite(led, HIGH);
        delay(300);                 //Right arrow
        break;

      case 16589023:
        moveLeft();                //left arrow
        digitalWrite(led, HIGH);
        delay(300);
        break;

      case 16617583:
        moveBackward();              //down arrow
        digitalWrite(led, HIGH);
        delay(300);
        break;


    }
    irrecv.resume();
  }
}


void moveForward()                                    //This function tells the robot to go forward
{
  Serial.println("");
  Serial.println("Moving forward");
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(RightMotorForward, HIGH);
}

void moveBackward()                                  //This function tells the robot to move backward
{
  Serial.println("");
  Serial.println("Moving backward");
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, HIGH);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, HIGH);
}

void moveLeft()                                      //This function tells the robot to turn left
{
  Serial.println("");
  Serial.println("Moving left");
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, HIGH);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(RightMotorForward, HIGH);
  delay(150);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(RightMotorForward, LOW);


}

void moveRight()                                    //This function tells the robot to turn right
{
  Serial.println("");
  Serial.println("Moving right");
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, HIGH);
  delay(150);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(RightMotorForward, LOW);
}

void moveStop()                                     //This function tells the robot to stop moving
{
  Serial.println("");
  Serial.println("Stopping");
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);
}
